{
      ZAPOCTOVY PROGRAM     ALENA ZAORALOVA   1.ROCNIK - M6
       ================================================================
              Clovece nezlob se  verse 1.0  3. zari 1996
       ================================================================


                        ====================
                             Dokumentace
                        ====================
  1) Zadani
       Tak to je celkem zrejme - ukolem bylo vytvorit klasickou lidovou
 stolni hru "Clovece nezlob se".
 Tato hra je urcena pro 1-4 hrace, z toho muze za 1-4 hrace hrat pocitac.
 Cilem je dostat jako prvni vsechny svoje (4) figurky do cilovych domecku
 uprostred hraci plochy.
 Pricemz zacinat (nasadit figurku na herni plochu) hrac muze az po hozeni
 sestky.
 Pokud hrac hodi sestku muze hazet jeste jednou.

  2) Datove struktury
     a) Pole: array [1..MaxPocetPolicek] of tSouradnice;
        - typova konstanta (pole) obsahujici realne souradnice jednotlivych
	  policek hraci plochy, po ktere pochoduji vsechny figurky + policka
          tzv. domovska (cilova), kde figurky konci
          ocislovani policek:
                           . . . .
                           .  57 .
                           .  58 .
               1 2 3 . . . .  59 . . . . . . . .
               52             60               .
               . 53,54,55,56  68    64,63,62,61.
               . . . . . . .  67 . . . . . . . .
                           .  66 .
                           .  65 .
                           . . . .

     b) Home: array [1..16] of tSouradnice;

        - typova konstanta (pole) obsahujici pocatecni (startovni) soradnice
          jednotlivych figurek.

     c) Kostky: array [1..4] of tSouradnice;
        - typova konstanta (pole) obsahujici souradnice hazecich kostek
          jednotlivych hracu (levy horni roh)

     d) PoleUk = array [1..MaxPocetPolicek] of pFigurka;
        - vlastni hraci plocha, kazde policko (tohoto pole = hraci plocha)
          ukazuje bud na figurku, ktera na tomto policku stoji, nebo ma
          hodnotu NIL, pokud na nem nic nestoji.

     e) Figurka: object;
        - vlastni figurka
        - promenne:
            Color - Zakladni barva figurky (take reprezentuje do ktere
	            skupiny patri (aneb ci je to figurka)).
            Color2- Barva aktivni figurky (zvyrazneni).
            Poloha- Pocet ujitych policek na herni plose.
            MyHome- Startovni souradnice (taktez souradnice, kam se ma
	            premistit po vyhozeni jinou figurkou)
            Podklad- znak (vcetne atributu (barev)) pod figurkou

        - procedury a fce:
            Draw  - Nakresli figurku na aktualni pozici
            ReNew - Obnovi pozadi pod figurkou
            RealPoloha- vypocita realnou (skutecnou polohu) figurky pomoci
                        poctu ujitych policek a posunu (jednotlive skupiny
			figurek (barvy, hraci) jsou od sebe na hernim planu
			vzdalene o "Posun" policek)
            Activate, DeActivate - zvyrazneni figurky a navraceni do normalu
            Test (OKolik)- testuje zda muze figurka ujit "Okolik" policek
                           vpred (true - muze, false - nemuze)
                           Napriklad pred nasazenim na herni plan musi
                           hrac hodit sestku, pokud uz jde do ciloveho
			   domecku musi jit na prazdne policko....to vse
			   se v teto funkci testuje
            WhoIsThere   - Zjisti, jaka figurka se nachazi o "Okolik" pozic
	                   dal (Vyuziva pri tom globalni pole ukazatelu
			   PoleUk, jehoz kazdy prvek (policko) ukazuje na
			   figurku, ktera na nem prave stoji), pokud tam
			   nemuze tahnout, vraci nulu, pokud tam zadna neni,
			   vraci 5 (figurek je max 4)

            Go (OKolik)  - Presune s OKolik policek vpred, pokud nemuze, nic
	                   se nestane.
                           Taktez se zde kontroluje preskoceni figurky a
                           moznost vyhry.
            GoHome       - Presune se na startovaci pozici

     f) Player: Object;
         promenne:
            Figurky : array[1..4] of pFigurka -  jednotlive figurky hrace
            Color : Byte;                     -  barva hrace
         procedury a fce (metody):
            Active; virtual; - vlastni akce (u kazdeho odvozeneho typu je
	                       jina)
     g) CompPlayer: Object (Player) \
             Typy odvozene od typu Player - 2 typy hrace (pocitac, uzivatel)
        UserPlayer: Object (Player) /

  3) Vlastni algoritmus
       ...neni vubec slozity.
       Na zacatku se inicializuji 2 typy hracu (jejich pocet zavisi na
       uzivateli) a pak se porad dokola volaji jejich akce dokud nektery
       hrac nezvitezi.

       Taktika pocitace:
       jednotlive moznosti tahu jsou nasledovne setrideny
       podle priority:
           1) Zjisti pokud muze nekoho vyhodit (preskocit), pokud ano
              tak ho vyhodi (pocitac je obvzlaste zakerny :-) )
           2) Pokud muze nasadit novou figurku
           3) Koukne se, zda je nektera blizko cile, pokud ano tak ji pouzije
           4) Pokud nebyla uskutecnena zadna z techto akci vybere vsechny
              kandidaty, kteri jsou schopni se posunout a z nich jednoho
              nahodne vybere

          - pri akci jeste kontroluje, zda si neskoci vlastni figurku

  4) Dalsi komentare:
 Popis jednotlivych procedurek a funkci je uveden vetsinou pred deklaraci
      dane procedury ci fce. (vcetne popisu vstupu a vystupu).

 Popis jednotlivych promennych (pripadne konstant) a jejich vyznam
      je uveden v deklaracni casti programu.

 V programu byly pouzity tyto unity:
       My        - Souhrn drobnych, casto pouzivanych konstant (napr. kody
                   klaves), procedurek a funkci pro praci s textovym
		   souborem, linearnim seznamem, retezci, obrazovkou,...)
       Wokynka   - unitka na "okenkoidni" uzivatelske rozhrani (Okynka,
                   ruzne requestry, nacitani stringu, nacitani jmena a
		   cesty souboru, tvorba formularu,...)

}
program Clovece;
uses My, Wokynka, Crt, Dos;
const
  PocetPolicek = 52;   {Pocet spolecnych policek}
  MaxPocetPolicek = PocetPolicek + 16;  {Pocet vsech policek vcetne
                                         cilovych "domecku"}
  Posun = 13;  {rozdil v poli mezi jednotlivymi hraci}
  Posun2 = 4;  {rozdil mezi cilovymi pozicemi (domecky)jednotlivych hracu}
  Barvy : array [1..4] of string[10] =
    ('MODRY','ZELENY','SV. MODRY','CERVENY');
type
  tSouradnice = record
    X, Y: Byte;
  end;


  tPole = array [1..MaxPocetPolicek] of tSouradnice; {vsechna policka}
  tKostky = array [1..4] of tSouradnice; {leve horni rohy kostek jednotlivych hracu}

  tHome = array [1..16] of tSouradnice; {domovske (startovni) policka)}
{----------------------------------------------------------------------------}
{--------------------------------  Figurka  ---------------------------------}
  pFigurka = ^Figurka;
  Figurka = object
    Color  : Byte;    { Umisteni a zakladni barva figurky }
    Color2 : Byte; {aktualni barva figurky}
    Poloha : Byte;  {Pocet ujitych policek}
    MyHome : tSouradnice; {Poloha domovskeho policka}
    Podklad: Word; {Aneb to co je (bylo) pod figurkou, aby se pak mohlo
                    obnovit pozadi}

    constructor Init (Barva, Poradi: Byte);
    procedure Draw;  {vykresleni figurky}
    procedure ReNew;  {Obnovi podklad pod figurkou}
    function RealPoloha: Byte;  {vypocet realne pozice}
    procedure Activate;         {zvyrazneni}
    procedure DeActivate;
    function Test (Okolik: Byte): Boolean;{test, zda muze postoupit o OKOLIK}
    function WhoIsThere (OKolik: Byte): Byte;  {Zjisti co za figurku je na
                                                policku OKOLIK dal}
    procedure Go (OKolik: Byte);  {Posune se o OKOLIK policek vpred}
    procedure GoHome;             {Presune se na startovni pozici}
  end;

{---------------------------------  Player  ---------------------------------}
  pPlayer =^Player;
  Player = object
    Figurky : array[1..4] of pFigurka;  {jednotlive figurky hrace}
    Color : Byte;                       {barva hrace}

    constructor Init (Barva: Byte);
    procedure Active; virtual;          {vlastni akce (u kazdeho odvozeneho
                                          typu je jina)}
  end;
{-----------------------------  CompPlayer  ---------------------------------}
  pCompPlayer =^CompPlayer;
  CompPlayer = object (Player)
    constructor Init (Barva: Byte);
    procedure Active; virtual;
  end;
{-----------------------------  UserPlayer  ---------------------------------}
  pUserPlayer =^ UserPlayer;
  UserPlayer = object (Player)
    constructor Init (Barva: Byte);
    procedure Active; virtual;
  end;
{----------------------------------------------------------------------------}
  tPoleUk = array [1..MaxPocetPolicek] of pFigurka; {kazdy prvek tohoto pole
  ukazuje na figurku, ktera na tomto poli stoji nebo je NILovy}
  tHraci = array [1..4] of pPlayer;   {vlastni hraci}
const
 {Souradnice policek hraciho pole}
  Pole : tPole = (
  (X: 8; Y:11),  (X: 12; Y:11), (X: 16; Y:11), (X: 20; Y:11), (X: 24; Y:11),
  (X: 28; Y:11), (X: 32; Y:11), (X: 36; Y:11), (X: 36; Y:9),  (X: 36; Y:7),
  (X: 36; Y:5),  (X: 36; Y:3),  (X: 40; Y:3),  (X: 44; Y:3),  (X: 44; Y:5),
  (X: 44; Y:7),  (X: 44; Y:9),  (X: 44; Y:11), (X: 48; Y:11), (X: 52; Y:11),
  (X: 56; Y:11), (X: 60; Y:11), (X: 64; Y:11), (X: 68; Y:11), (X: 72; Y:11),
  (X: 72; Y:13), (X: 72; Y:15), (X: 68; Y:15), (X: 64; Y:15), (X: 60; Y:15),
  (X: 56; Y:15), (X: 52; Y:15), (X: 48; Y:15), (X: 44; Y:15), (X: 44; Y:17),
  (X: 44; Y:19), (X: 44; Y:21), (X: 44; Y:23), (X: 40; Y:23), (X: 36; Y:23),
  (X: 36; Y:21), (X: 36; Y:19), (X: 36; Y:17), (X: 36; Y:15), (X: 32; Y:15),
  (X: 28; Y:15), (X: 24; Y:15), (X: 20; Y:15), (X: 16; Y:15), (X: 12; Y:15),
  (X: 8; Y:15),  (X: 8; Y:13),
 { + Cilove souradnice (domecku)}
  (X: 14; Y:13), (X: 18; Y:13), (X: 22; Y:13), (X: 26; Y:13),
  (X: 40; Y:6),  (X: 40; Y:8),  (X: 40; Y:10), (X: 40; Y:12),
  (X: 66; Y:13), (X: 62; Y:13), (X: 58; Y:13), (X: 54; Y:13),
  (X: 40; Y:20), (X: 40; Y:18), (X: 40; Y:16), (X: 40; Y:14));

 {Souradnice domacich policek}
  Home : tHome = (
  (X: 8; Y:6),   (X: 12; Y:6),  (X: 8; Y:8),   (X: 12; Y:8),
  (X: 50; Y:3),  (X: 54; Y:3),  (X: 50; Y:5),  (X: 54; Y:5),
  (X: 68; Y:18), (X: 72; Y:18), (X: 68; Y:20), (X: 72; Y:20),
  (X: 26; Y:21), (X: 30; Y:21), (X: 26; Y:23), (X: 30; Y:23));

  Kostky : tKostky = (
  (X: 19; Y:4),  (X: 60; Y:4),  (X: 51; Y:18), (X: 9; Y:18));
  Fig = '';  {Takhle vypada figurka}
{================================   V  A  R   ===============================}
var
  PoleUk: tPoleUk;
  GameOver: 0..4;    {barva hrace, ktery vyhral}
  PocetHracu: Byte;
  PocetCompHracu, PocetUzivHracu: Byte;
  i,j: Byte;
  Hrac: tHraci;
  Hlaska : string;
{===============   P R O C E D U R K Y    &    F U N K C E   ================}
{-----------------------------  HideCursor  ---------------------------------}
{  Schova kurzor }
Procedure HideCursor;  assembler;
asm
  mov      ah,$01  { Function number }
  mov      ch,$20
  mov      cl,$00
  Int      $10     { Call BIOS }
end;  { HideCursor }

{--------------------------  RestoreCursor  ---------------------------------}
{  obnovi kursor }
Procedure RestoreCursor;  assembler;
asm
  mov      ah,$01  { Function number }
  mov      ch,$06  { Starting scan line }
  mov      cl,$07  { Ending scan line }
  int      $10     { Call BIOS }
end; { RestoreCursor }

{---------------------------------  Kostka  ---------------------------------}
{ Vstup - Barva....ktery hrac to haze (1..4),
          Comp.....zda se jedna o pocitac (true - pocitac, false - uzivatel)
  Vystup- to co hodi ta kostka
}
function Kostka (Barvicka: Byte; Comp: Boolean): Byte;
var
  X,Y, Hodnota: Byte;
  R1,R2,R3 : string [8];
  Pom: Boolean;
const
  Nic     = '        ';
  Puntik1 = '    o   ';
  Puntik2 = ' o     o';
  Puntik3 = ' o      ';
  Puntik4 = '       o';
begin { Kostka }
  X := Kostky[Barvicka].X;   {souradnice nakreslene kostky}
  Y := Kostky[Barvicka].Y;

  Ramecek (X,Y,X+10,Y+4,Barvicka+8, Barvicka,'', Single);
  Obdelnik (X+1,Y+1,X+9,Y+3,Barvicka);
  Window (X+1,Y+1,X+9,Y+3);
  Pom := False;
  repeat
    Hodnota := Random (6)+1;
    R1 := Nic; R2 := Nic; R3 := Nic;
    case Hodnota of
      1:R2 := Puntik1;
      2:begin {}
          R1 := Puntik3;
          R3 := Puntik4;
        end; {}
      3:begin {}
          R1 := Puntik3;
          R2 := Puntik1;
          R3 := Puntik4;
        end; {}
      4:begin {}
          R1 := Puntik2;
          R3 := Puntik2;
        end; {}
      5:begin {}
          R1 := Puntik2;
          R2 := Puntik1;
          R3 := Puntik2;
        end; {}
      6:begin {}
          R1 := Puntik2;
          R2 := Puntik2;
          R3 := Puntik2;
        end; {}
    end; {case}
    SetColors (Barvicka+8, Barvicka);
    WriteXY (1,1,R1);
    WriteXY (1,2,R2);
    WriteXY (1,3,R3);
    Delay (20);
    if KeyPressed then
      begin
        Pom := True;
        readkey;
      end;
  until Pom or Comp;
  Delay (500);

  Window (1,1,80,25);
  Ramecek (X,Y,X+10,Y+4,7,0,'', Single);
  Obdelnik (X+1,Y+1,X+9,Y+3,0);
  Window (X+1,Y+1,X+9,Y+3);
  SetColors (7,0);
  WriteXY (1,1,R1);
  WriteXY (1,2,R2);
  WriteXY (1,3,R3);
  Window (1,1,80,25);

  Kostka := Hodnota;
end;  { Kostka }
{----------------------------------  Konec  ---------------------------------}
{ Zepta se, zda chce koncit a pripadne zkonci...}
procedure Konec;
var
  Volba : Byte;
begin { Konec }
  Volba := 2;
  ABCRequest ('Ukoncit hru?',Volba, Red, Vodorovne,
    'Ano|Ne|');
  if Volba < 2  then
    begin
      StandartScreen;
      Writeln ('Bye, bye...');
      Halt;
    end;
end;  { Konec }
{------------------------------  HraciPole  ---------------------------------}
{ Vykresli hraci pole }
procedure HraciPole;
begin { HraciPole }
  StandartScreen;
  Writeln;
  {|~~}
  Writeln ('                                 ͻ ͻ                  ');
  Writeln ('                                                                   ');
  Writeln ('                                 ͹ ͹                  ');
  Writeln ('     ͻ                      Ķ                            ');
  Writeln ('                              ͹   ͹ ͼ                  ');
  Writeln ('     ͹                      Ķ                               ');
  Writeln ('                              ͹   ͹                            ');
  Writeln ('     ͼ                      Ķ                               ');
  Writeln ('     ͹   ͻ');
  Writeln ('                             Ķ                        ');
  Writeln ('     ͼ   ͹');
  Writeln ('                              Ĵ                         ');
  Writeln ('     ͻ   ͹');
  Writeln ('                             Ķ                        ');
  Writeln ('     ͹   ͼ');
  Writeln ('                                    Ķ                      ͻ');
  Writeln ('                                 ͹   ͹                         ');
  Writeln ('                                    Ķ                      ͹');
  Writeln ('                       ͻ ͹   ͹                         ');
  Writeln ('                                 Ķ                      ͼ');
  Writeln ('                       ͹ ͹                            ');
  Writeln ('                                                                   ');
  Writeln ('                       ͼ ͼ                            ');

end;  { HraciPole }

{-----------------------------  InitPoleUk  ---------------------------------}
{  inicializuje pole ukazatelu (vsechny ukazatele jsou NIL)                  }
procedure InitPoleUk;
var
  i : Byte;
begin { InitPoleUk }
  for i := 1 to MaxPocetPolicek do
    PoleUk[i] := nil;
  GameOver := 0;
  Randomize;
end;  { InitPoleUk }

{-----------------------------------  Uvod  ---------------------------------}
{Uvodni hlasky a dotazy na pocet hracu ....}
procedure Uvod;
var
  pom: string;
  i,j: Byte;
begin { Uvod }
  TextBackGround (Green);
  ClrScr;
  Pozadi (Sroub, Green);
  Message ('Clovece nezlob severse 1.04.zari 1996', red);

 {Zadani poctu vsech hracu}
  repeat
    Pom := '4';
    ReadString ('Zadej pocet hracu:',Pom, '1234',Blue,1);
    if Pom = '' then Konec;
  until Pom <> '';
  PocetHracu := MyVal (Pom);

 {Pocet Computer-hracu}
  repeat
    Pom := '3';
    ReadString ('Kolik z techto hracu bude pocitac?',Pom,
                '0'+Mid ('1234',1,PocetHracu),Blue,1);
                {ten MID tam udava povolene znaky (pocet computer-hracu)
		 vzhledem k poctu vsech hracu}
    if Pom = '' then Konec;
  until Pom <> '';
  PocetCompHracu := MyVal (Pom);

  Message ('Ovladani je velmi jednoduche: ' +
           'Vyber figurky..........................Sipky ()' +
	   'Potvrzovani volby, hod kostkou.........Enter      ',cyan);
  StandartScreen;
  HraciPole;
  InitPoleUk;
  {Vybarveni nekterych policek}
  for i := 1 to PocetHracu do
    begin
      TextColor (i);
        for j := 1 to 4 do
          begin {}
            WriteXY (Home[(i-1)*4 + j].X, Home[(i-1)*4 + j].Y, '');
            WriteXY (Pole[(i-1)*4 + j+ PocetPolicek].X,
	             Pole[(i-1)*4 + j+ PocetPolicek].Y, '');
          end; {}
    end;
end;  { Uvod }

{---------------------------  Figurka.Init  ---------------------------------}
{ Barva  - barva figurky
  Poradi - kolikata figurka to je ze skupiny}
constructor Figurka.Init (Barva, Poradi: Byte);
begin { Figurka.Init }
  Color := Barva;
  Color2 := Barva;
  MyHome := Home [(Barva-1)*4+Poradi];
  Poloha := 0;
  Draw;
end;  { Figurka.Init }

{---------------------------  Figurka.Draw  ---------------------------------}
{ Vykresli figurku na aktualni pozici }
procedure Figurka.Draw;
var
  X,Y: Byte;
begin { Figurka.Draw }
  if Poloha = 0 then
    begin {Na startu}
      X := MyHome.X;
      Y := MyHome.Y;
    end   {Na startu}
  else
    begin
      X := Pole [RealPoloha].X;
      Y := Pole [RealPoloha].Y;
    end;
  Podklad := MemW [Vidseg: (160*(Y-1) + 2*(X-1))];
  TextColor (Color2);
  WriteXY (X,Y,Fig);
end;  { Figurka.Draw }
{--------------------------  Figurka.Renew  ---------------------------------}
{  Obnovi pozadi pod figurkou }
procedure Figurka.Renew;
var
  X,Y: Byte;
begin { Figurka.Renew }
  if Poloha = 0 then
    begin {Na startu}
      X := MyHome.X;
      Y := MyHome.Y;
    end   {Na startu}
  else
    begin
      X := Pole [RealPoloha].X;
      Y := Pole [RealPoloha].Y;
    end;
  MemW [Vidseg: (160*(Y-1) + 2*(X-1))] := Podklad;
end;  { Figurka.Renew }
{---------------------  Figurka.RealPoloha  ---------------------------------}
{ Vypocita skutecnou pozici }
function Figurka.RealPoloha: Byte;
var
  Pom : Byte;
begin { Figurka.RealPoloha }
  Pom := (Color-1)*Posun + Poloha;
  if Pom > PocetPolicek then Pom := Pom - PocetPolicek;

  if Poloha > PocetPolicek then Pom := (Color-1)*Posun2 + Poloha;
  RealPoloha := Pom;
end;  { Figurka.RealPoloha }
{-----------------------  Figurka.Activate  ---------------------------------}
procedure Figurka.Activate;
begin { Figurka.Activate }
  Color2 := Color2 + 8;
  ReNew;
  Draw;
end;  { Figurka.Activate }
{---------------------  Figurka.DeActivate  ---------------------------------}
procedure Figurka.DeActivate;
begin { Figurka.DeActivate }
  Color2 := Color2 - 8;
  ReNew;
  Draw;
end;  { Figurka.DeActivate }
{---------------------------  Figurka.Test  ---------------------------------}
{  Fce vraci TRUE pokud se figurka muze posunout o "OKolik" policek,
           a FALSE pokud nemuze }
function Figurka.Test (Okolik: Byte): Boolean;
var
  Pom : Boolean;
begin { Figurka.Test }
  Pom := True;
 {Proc tedy nemuze tahnout??}
{  (1) Uz nema kam jit}
  if Poloha + OKolik > Pocetpolicek + 4 then Pom := False;
{  (2) Je na staru a nepadla mu sestka}
  if (Poloha = 0) and (OKolik <> 6) then Pom := False;
{  (3) Chce jit do domecku (do cile) ale misto je uz obsazeno}
{}if Pom and (Poloha + Okolik > PocetPolicek) and
     (PoleUk [(Color-1)*Posun2 + Poloha+OKolik] <> nil) then Pom := False;
  Test := Pom;
end;  { Figurka.Test }
{---------------------  Figurka.WhoIsThere  ---------------------------------}
{ Zjisti jaka figurka se nachazi o "Okolik" pozic dal, pokud tam nemuze
  tahnout, vraci nulu, Pokud tam zadna neni, vraci 5 (figurek je max 4)}
function Figurka.WhoIsThere (OKolik: Byte): Byte;
var
  X: Byte;  {To je vysledna pozice po ujiti OKOLIK policek}
begin { Figurka.WhoIsThere }
  WhoIsThere := 0;
  if not Test (OKolik) then exit;  {nemuze postoupit => nema to vyznam}
  if Poloha = 0 then X := (Color-1)*Posun + 1  {nastupuje sestkou}
  else X := (Color-1)*Posun + Poloha + Okolik;    {jinak}
  {Spec pripady:}
  {  1) pretoceni }
  if X > PocetPolicek then X := X - PocetPolicek;
  {  2) v domecku }
  if Poloha + Okolik > PocetPolicek then X := (Color-1)*Posun2 + Poloha +
                                              Okolik;

  if PoleUk [X] <> nil then WhoIsThere := PoleUk[X]^.Color
  else WhoIsThere := 5;

end;  { Figurka.WhoIsThere }
{-----------------------------  Figurka.Go  ---------------------------------}
procedure Figurka.Go (OKolik: Byte);
var
  i, Zmena: Byte;
  Pom : Byte;
begin { Figurka.Go }
  if not Test (OKolik) then Exit;

  if Poloha = 0 then
    begin {Jeste doma - Nasazeni figurky na pole}
       ReNew;
       Poloha := 1;
       Draw;
    end   {Jeste doma}
  else
    begin  {Nekde v poli}
      PoleUk [RealPoloha] := nil;
      if Poloha + Okolik > PocetPolicek then
        begin { Uz poleze do domecku (do cile)}
        {nasleduje kontrola, zda uz nahodou tento hrac nevyhral,
        tedy, zda uz nema vsechny figurky krome teto (aktualni) doma}
          Pom := 0;
          for i := 1 to 4 do
            if PoleUk [(Color-1)*Posun2 + PocetPolicek + i] <> nil then
	      inc (Pom);
          if Pom = 3 then GameOver := Color;
        end;  { Uz poleze do domecku (do cile)}

        for i := 1 to Okolik do
          begin {Posun na cilovou pozici}
            ReNew;
            Inc (Poloha);
            Draw;
            Delay (200);
          end;  {Posun na cilovou pozici}
    end;   {Nekde v poli}

  i := RealPoloha;
  if PoleUk [i] <> nil then
    begin {Preskoceni figurky :-)}
      Podklad := PoleUk [i]^.Podklad;
      PoleUk [i]^.GoHome;  {preskocena jde domu  :-) }
    end;  {Preskoceni figurky :-)}

  PoleUk [i] := @self;
end;  { Figurka.Go }
{-------------------------  Figurka.GoHome  ---------------------------------}
procedure Figurka.GoHome;
begin { Figurka.GoHome }
  Poloha := 0;
  Draw;
end;  { Figurka.GoHome }
{------------------------------  Player.Init  ---------------------------------}
constructor Player.Init (Barva: Byte);
var
  i: Byte;
begin { Player.Init }
  Color := Barva;
{inicializace figurek}
  for i := 1 to 4 do
    Figurky[i] := New (pFigurka, Init (Color,i));
end;  { Player.Init }
{--------------------------  Player.Active  ---------------------------------}
procedure Player.Active;
begin { Player.Active }
end;  { Player.Active }
{------------------------  CompPlayer.Init  ---------------------------------}
constructor CompPlayer.Init (Barva: Byte);
begin { CompPlayer.Init }
  Player.Init (Barva);
end;  { CompPlayer.Init }
{----------------------  CompPlayer.Active  ---------------------------------}
procedure CompPlayer.Active;
var
  PocetKandid,Hod,i,First, Found: Byte;
  Ok: Boolean;
  Kandid : array[1..4] of Byte;
begin { CompPlayer.Active }
  repeat
    Hod := Kostka (Color, True);
    Ok := True;
    First := 4;

    for i := 4 downto 1 do
      if Figurky[i]^.Test (Hod) then
        begin
          Ok := False;
          First := i; {ted zjistime cislo prvni fig., ktera se muze posunout}
        end;


    if Ok then Exit; {Nemuze tahnout}

    Found := 0;

  {test na nasazeni}
    if Hod = 6 then
      for i := 4 downto First do
        if (Figurky[i]^.Poloha = 0) and
	   (Figurky[i]^.WhoisThere(Hod) <> Color) then Found := i;

  {test na preskoceni}
    for i := First to 4 do
      begin {}
        if (Figurky[i]^.WhoisThere(Hod) <> Color) and {aby neskocil na sebe}
           (Figurky[i]^.WhoisThere(Hod) <> 0) and     {=0 --> nemuze skocit}
           (Figurky[i]^.WhoisThere(Hod) <> 5) then     {prazdne policko}
          Found := i;
      end; {}

  {test na figurky, ktere se jiz blizi do cile}
    if Found = 0 then
      for i := First to 4 do
        if (Figurky[i]^.Poloha > 40) and
           (Figurky[i]^.WhoisThere(Hod) <> Color) and {aby neskocil na sebe}
           (Figurky[i]^.WhoisThere(Hod) <> 0) then     {=0 --> nemuze skocit}
           Found := i;

  {nyni se vyberou kandidati, a pozdeji se mezi nimi nahodne rozhodne}
  {Tedy pokud se nenaslo neco lepsiho}

    if Found = 0 then  {Tedy pokud se jeste zadna lepsi sance nenasla}
      begin
        PocetKandid := 0;
        for i := first to 4 do
          begin {}
            if (Figurky[i]^.WhoisThere (Hod) <> Color) and {neskace na sebe}
               (Figurky[i]^.WhoisThere (Hod) <> 0) then   {nemuze tam}
              begin {}
                Inc (PocetKandid);
                Kandid[PocetKandid] := i;
              end; {}
          end; {}

        if PocetKandid = 0 then Found := First
        else Found := Kandid [Random(PocetKandid)+1];
      end;

    {if Found = 0 then Found := First;}
    Figurky[Found]^.Activate;
    Figurky[Found]^.Go (Hod);
    Figurky[Found]^.DeActivate;

  until Hod <> 6;
end;  { CompPlayer.Active }
{------------------------  UserPlayer.Init  ---------------------------------}
constructor UserPlayer.Init (Barva: Byte);
begin { UserPlayer.Init }
  Player.Init (Barva);
end;  { UserPlayer.Init }
{----------------------  UserPlayer.Active  ---------------------------------}
{ Vlastni akce hrace (uzivatele)}
procedure UserPlayer.Active;
var
  Hod : Byte;
  Oldi, i, First : Byte;
  OK : Boolean;
  Z: Char;
begin { UserPlayer.Active }
  repeat
    Hod := Kostka (Color, False);
    Ok := True;
    First := 4;

    for i := 4 downto 1 do
      if Figurky[i]^.Test (Hod) then
        begin
          Ok := False;
          First := i; {ted zjistime cislo prvni fig., ktera se muze posunout}
        end;

    i := First;
    if not Ok then Figurky [i]^.Activate;

    while not Ok do
      begin {While}
        Z := Readkey;
        Oldi := i;
        Case Z of
          #00:
            begin {#00}
              Z := Readkey;
              case Z of
                Left :
	          if i = 1 then i := 4
                  else Dec (i);
                Right:
                  if i = 4 then i := 1
                  else Inc (i);
              end; {case2}
            end; {#00}
          Esc: Konec;
          Enter:   {Vybrali jsem figurku}
            begin {Enter}
              Ok := Figurky[i]^.Test (Hod);
              if Ok then  {Muze postoupit}
	        begin
	          Figurky[i]^.Go (Hod);
                  Figurky[i]^.DeActivate;
                end;
            end;  {Enter}
        end; {case1}

        if Oldi <> i then {pokud jsme vybrali jinou figurku}
          begin
            Figurky[Oldi]^.Deactivate;
	    Figurky[i]^.Activate;
          end;
      end; {While}
  until Hod <> 6;
end;  { UserPlayer.Active }

{============================  HLAVNI PROGRAM  ==============================}
begin { HLAVNI PROGRAM }
  repeat
    Uvod;
    HideCursor;
   {Inicializace jednotlivych hracu}
    PocetUzivHracu := PocetHracu - PocetCompHracu;
    for i := 1 to PocetUzivHracu do
      Hrac[i] := New (pUserPlayer, Init (i));
    for j := PocetUzivHracu+1 to PocetHracu  do
      Hrac[j] := New (pCompPlayer, Init (j));

   {Vlastni hra}
    While GameOver = 0 do
      for i := 1 to PocetHracu do
        begin
          Hrac[i]^.Active;
          if Keypressed then
	    if Readkey = Esc then konec;
          if GameOver <> 0 then Break;
        end;
    Hlaska := 'Aaaaa mame tady viteze - ' + Barvy[GameOver] + ' hrac pod '+
    'skvelym vedenim ';
    if GameOver > PocetUzivHracu then Hlaska := Hlaska + 'vaseho pocitace.'
    else Hlaska := Hlaska + 'chrabreho uzivatele.';

    Message (Hlaska, GameOver);
    konec;
    RestoreCursor;
  until false;

end.